--  2005-07-19AI
require "./AI/Const"
require "./AI/Util"

-----------------------------
-- zNXԒ萔
-----------------------------
IDLE_ST					= 0  -- ҋ@
FOLLOW_ST				= 1  -- AP~XgǏ]
CHASE_ST				= 2  -- ^[QbgǐՏ
ATTACK_ST				= 3  -- U
MOVE_CMD_ST				= 4  -- ړR}ht
STOP_CMD_ST				= 5  -- ~R}ht
ATTACK_OBJECT_CMD_ST			= 6  -- ΏێwUR}ht
ATTACK_AREA_CMD_ST			= 7  -- ͈͍UR}ht
PATROL_CMD_ST				= 8  -- pg[iړjR}ht
HOLD_CMD_ST				= 9  -- z[hR}ht
SKILL_OBJECT_CMD_ST			= 10 -- ΏێwXLR}ht
SKILL_AREA_CMD_ST			= 11 -- ͈̓XLR}ht
FOLLOW_CMD_ST				= 12 -- Ǐ]R}ht
----------------------------



------------------------------------------
-- O[oϐivOŜŋʂŎgtO݂Ȃ́j
------------------------------------------
MyState				= IDLE_ST	-- žݏԁil͑ҋ@ԁj
MyEnemy				= 0		-- z^[QbgĂG̃LN^[ID
MyDestX				= 0		-- z̖ڕWWXiړ / XLgpWj
MyDestY				= 0		-- z̖ڕWWYiړ / XLgpWj
MyPatrolX			= 0		-- zpg[iړjn_WX
MyPatrolY			= 0		-- zpg[iړjn_WY
-- iP~sŕR}h͂ꍇAɏԂɋL܂j
ResCmdList			= List.new()	-- s̓R}hXg
MyID				= 0		-- zg̃LN^[ID
MySkill				= 0		-- zgƂĂXL
MySkillLevel			= 0		-- zgƂĂXLx
------------------------------------------









------------- R}hƂ̏  ---------------------

-------------------------------------------
-- ړR}h󂯕tꍇ̏
--   <> X : ړwXW
--          Y : ړwYW
-------------------------------------------
function	OnMOVE_CMD (x,y)
	
	TraceAI ("OnMOVE_CMD")		-- fobOo

	if ( x == MyDestX and y == MyDestY and MOTION_MOVE == GetV(V_MOTION,MyID)) then
		return	-- z̍WړڕWWƓŁAzړ[VȂΉȂB

	end

	-- P~ƃz̊Ԃ̋擾 (x,y)
	local curX, curY = GetV (V_POSITION,MyID)
	-- P~ƃz̋15}Xȏ̂Ƃ
	if (math.abs(x-curX)+math.abs(y-curY) > 15) then	-- ړIn苗ȏȂ (T[o[ŃS͏Ȃ)
		List.pushleft (ResCmdList,{MOVE_CMD,x,y})	-- X̖ړInւ̈ړ\񂷂B
		x = math.floor((x+curX)/2)	-- Ԓn_ɐɈړB
		y = math.floor((y+curY)/2)	-- 
	end

	Move (MyID,x,y)			-- (x,y)WɃzړJn
	
	MyState = MOVE_CMD_ST		-- zԂړR}htԂɂ
	MyDestX = x					-- ړxWxɂ
	MyDestY = y					-- ړyWyɂ
	MyEnemy = 0					-- ^QɂĂG^Q
	MySkill = 0					-- ^QɂĂG^Q

end


-------------------------------------------
-- ~R}h󂯕tꍇ̏
-------------------------------------------
function	OnSTOP_CMD ()

	TraceAI ("OnSTOP_CMD")		-- fobOo

	-- z[VłȂ
	if (GetV(V_MOTION,MyID) ~= MOTION_STAND) then
		Move (MyID,GetV(V_POSITION,MyID))		-- ž݈ʒuŒ~
	end
	MyState = IDLE_ST			-- zԂҋ@Ԃɂ
	MyDestX = 0					-- ڕWxWNA
	MyDestY = 0					-- ڕWyWNA
	MyEnemy = 0					-- ^QɂĂG^Q
	MySkill = 0					-- gp悤ƂĂXLLZ

end


-------------------------------------------
-- ΏێwUR}h󂯕tꍇ̏
--   <> id : UΏۂ̃LN^[id
-------------------------------------------
function	OnATTACK_OBJECT_CMD (id)

	TraceAI ("OnATTACK_OBJECT_CMD")		-- fobOo

	MySkill = 0		-- gp悤ƂĂXLLZ
	MyEnemy = id		-- id̓G^[Qbgɂ
	MyState = CHASE_ST	-- zԂ^[QbgǐՏԂɂ

end


-------------------------------------------
-- ΏێwUR}h󂯕tꍇ̏
--   <> x : U͈͂̒SxW
--          y : U͈͂̒SyW
-------------------------------------------
function	OnATTACK_AREA_CMD (x,y)

	TraceAI ("OnATTACK_AREA_CMD")	-- fobOo

	-- z̍WڕWWƈႤAzړ[VłȂ
	if (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION,MyID)) then
		Move (MyID,x,y)				-- (x,y)WɃzړJn
	end
	MyDestX = x						-- ڕWxWxɂ
	MyDestY = y						-- ڕWyWyɂ
	MyEnemy = 0						-- ^QɂĂG^Q
	MyState = ATTACK_AREA_CMD_ST	-- zԂ͈͍UR}htԂɂ
	
end


-------------------------------------------
-- pg[R}h󂯕tꍇ̏
-- pg[ł́Az݈͌ʒuƎwʒu
--   <> x : pg[xW
--          y : pg[yW
-------------------------------------------
function	OnPATROL_CMD (x,y)

	TraceAI ("OnPATROL_CMD")	-- fobOo

	-- žݍWpg[JnWɂ
	MyPatrolX , MyPatrolY = GetV (V_POSITION,MyID)
	MyDestX = x					-- ڕWxWxɂ
	MyDestY = y					-- ڕWyWyɂ
	Move (MyID,x,y)				-- (x,y)WɃzړJn
	MyState = PATROL_CMD_ST		-- zԂpg[R}htԂɂ

end


-------------------------------------------
-- z[hR}h󂯕tꍇ̏
-------------------------------------------
function	OnHOLD_CMD ()

	TraceAI ("OnHOLD_CMD")		-- fobOo

	MyDestX = 0					-- ڕWxWNA
	MyDestY = 0					-- ڕWyWNA
	MyEnemy = 0					-- ^QɂĂG^Q
	MyState = HOLD_CMD_ST		-- zԂz[hR}htԂɂ

end


-------------------------------------------
-- ΏێwXLR}h󂯕tꍇ̏
--   <> level : gpXLx
--          skill : gpXL
--          id    : Ώۂ̃LN^[id
-------------------------------------------
function	OnSKILL_OBJECT_CMD (level,skill,id)

	TraceAI ("OnSKILL_OBJECT_CMD")		-- fobOo

	MySkillLevel = level		-- gpXLxw
	MySkill = skill				-- gpXL
	MyEnemy = id				-- id̓G^[Qbgɂ
	MyState = CHASE_ST			-- zԂ^[QbgǐՏԂɂ

end


-------------------------------------------
-- ͈̓XLR}h󂯕tꍇ̏
--   <> level : gpXLx
--          skill : gpXL
--          x     : XLwxW
--          y     : XLwyW
-------------------------------------------
function	OnSKILL_AREA_CMD (level,skill,x,y)

	TraceAI ("OnSKILL_AREA_CMD")	-- fobOo

	Move (MyID,x,y)					-- (x,y)WɃzړJn
	MyDestX = x					-- ڕWxWxɂ
	MyDestY = y					-- ڕWyWyɂ
	MySkillLevel = level		-- gpXLxw
	MySkill = skill				-- gpXL
	MyState = SKILL_AREA_CMD_ST	-- ͈̓XLR}htԂɂ
	
end


-------------------------------------------
-- Ǐ]R}h󂯕tꍇ̏
-------------------------------------------
function	OnFOLLOW_CMD ()

	-- 鉂h 鉂al ܏ca m bQ. 
	if (MyState ~= FOLLOW_CMD_ST) then	-- Ǐ]R}htԂł͂ȂȂ
		MoveToOwner (MyID)				-- P~̂Ƃ܂ňړJn
		MyState = FOLLOW_CMD_ST			-- Ǐ]R}ht
		MyDestX, MyDestY = GetV (V_POSITION,GetV(V_OWNER,MyID))		-- P~ʒuڕWWɂ
		MyEnemy = 0					-- ^QɂĂG^Q
		MySkill = 0					-- gp悤ƂĂXLLZ
		TraceAI ("OnFOLLOW_CMD")	-- fobOo
	else	-- Ǐ]R}htԂ̂Ƃ
		MyState = IDLE_ST		-- zԂҋ@Ԃɂ
		MyEnemy = 0 
		MySkill = 0
		TraceAI ("FOLLOW_CMD_ST --> IDLE_ST")	-- fobOo
	end

end


-------------------------------------------
-- R}h͂̐U蕪
-------------------------------------------
function	ProcessCommand (msg)
	-- P~̓͂ȉ̃R}h̎AΉR}htĂяoB
	if		(msg[1] == MOVE_CMD) then	-- ړR}h
		OnMOVE_CMD (msg[2],msg[3])
		TraceAI ("MOVE_CMD")
	elseif	(msg[1] == STOP_CMD) then	-- ~R}h
		OnSTOP_CMD ()
		TraceAI ("STOP_CMD")
	elseif	(msg[1] == ATTACK_OBJECT_CMD) then	-- ΏێwUR}h
		OnATTACK_OBJECT_CMD (msg[2])
		TraceAI ("ATTACK_OBJECT_CMD")
	elseif	(msg[1] == ATTACK_AREA_CMD) then	-- ͈͍UR}h
		OnATTACK_AREA_CMD (msg[2],msg[3])
		TraceAI ("ATTACK_AREA_CMD")
	elseif	(msg[1] == PATROL_CMD) then	-- pg[R}h
		OnPATROL_CMD (msg[2],msg[3])
		TraceAI ("PATROL_CMD")
	elseif	(msg[1] == HOLD_CMD) then	-- z[hR}h
		OnHOLD_CMD ()
		TraceAI ("HOLD_CMD")
	elseif	(msg[1] == SKILL_OBJECT_CMD) then	-- ΏێwXLR}h
		OnSKILL_OBJECT_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_OBJECT_CMD")
	elseif	(msg[1] == SKILL_AREA_CMD) then	-- ͈̓XLR}h
		OnSKILL_AREA_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_AREA_CMD")
	elseif	(msg[1] == FOLLOW_CMD) then	-- Ǐ]R}h
		OnFOLLOW_CMD ()
		TraceAI ("FOLLOW_CMD")
	end
end


-------------- zԂƂ̏  --------------------

-------------------------------------------
-- ҋ@Ԃ̏
-------------------------------------------
function	OnIDLE_ST ()
	
	TraceAI ("OnIDLE_ST")

	local cmd = List.popleft(ResCmdList)
	if (cmd ~= nil) then	-- R}h͂
		ProcessCommand (cmd)	-- ΉR}h̎ts
		return 
	end

	local	object = GetOwnerEnemy (MyID)	-- P~UĂG̃LN^[id擾
	if (object ~= 0) then			-- P~UĂGȂ
		MyState = CHASE_ST	-- zԂ^[QbgǐՏԂɂ
		MyEnemy = object	-- object̓G^[Qbgɂ
		TraceAI ("IDLE_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
		return	-- ߂
	end

	object = GetMyEnemy (MyID)	-- z̓G̃LN^[id擾
	if (object ~= 0) then		-- z̓GȂ
		MyState = CHASE_ST	-- zԂ^[QbgǐՏԂɂ
		MyEnemy = object	-- object̓G^[Qbgɂ
		TraceAI ("IDLE_ST -> CHASE_ST : ATTACKED_IN")
		return	-- ߂
	end

	local distance = GetDistanceFromOwner(MyID)	-- P~Ƃ̋擾
	if ( distance > 3 or distance == -1) then	-- P~܂ł̋3艓EOȂ
		MyState = FOLLOW_ST	-- zԂǏ]Ԃɂ
		TraceAI ("IDLE_ST -> FOLLOW_ST")
		return;	-- ߂
	end

end


-------------------------------------------
-- Ǐ]Ԃ̏
-------------------------------------------
function	OnFOLLOW_ST ()

	TraceAI ("OnFOLLOW_ST")

	if (GetDistanceFromOwner(MyID) <= 3) then		-- P~Ƃ̋3ȓȂ
		MyState = IDLE_ST	-- zԂҋ@Ԃɂ
		TraceAI ("FOLLOW_ST -> IDLW_ST")
		return;
	-- P~Ƃ̋3ȓȂāAz̃[V[VȂ
	elseif (GetV(V_MOTION,MyID) == MOTION_STAND) then
		MoveToOwner (MyID)	-- P~̂Ƃ܂ňړJn
		TraceAI ("FOLLOW_ST -> FOLLOW_ST")
		return;
	end

end


-------------------------------------------
-- ^[QbgǐՏԂ̏
-------------------------------------------
function	OnCHASE_ST ()

	TraceAI ("OnCHASE_ST")

	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- GEOɏoȂ
		MyState = IDLE_ST	-- zԂҋ@Ԃɂ
		MyEnemy = 0	-- ^QɂĂG^Q
		MyDestX, MyDestY = 0,0	-- ڕWW΃NA
		TraceAI ("CHASE_ST -> IDLE_ST : ENEMY_OUTSIGHT_IN")
		return
	end
	if (true == IsInAttackSight(MyID,MyEnemy)) then	-- GU͈͂ɓ
		MyState = ATTACK_ST	-- zԂUԂɂ
		TraceAI ("CHASE_ST -> ATTACK_ST : ENEMY_INATTACKSIGHT_IN")
		return
	end

	local x, y = GetV (V_POSITION,MyEnemy)	-- G̍W擾
	if (MyDestX ~= x or MyDestY ~= y) then			-- ڕWWɓGȂ
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);	-- G̍WڕWWɂ
		Move (MyID,MyDestX,MyDestY)	-- G̍WֈړJn
		TraceAI ("CHASE_ST -> CHASE_ST : DESTCHANGED_IN")
		return
	end

end


-------------------------------------------
-- UԂ̏
-------------------------------------------
function	OnATTACK_ST ()

	TraceAI ("OnATTACK_ST")
	
	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- GEOɏo
		MyState = IDLE_ST	-- zԂҋ@Ԃɂ
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return 
	end

	if (MOTION_DEAD == GetV(V_MOTION,MyEnemy)) then	-- GɃ[VɂȂ
		MyState = IDLE_ST	-- zԂҋ@Ԃɂ
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return
	end
		
	if (false == IsInAttackSight(MyID,MyEnemy)) then	-- GUE̊Oɏo
		MyState = CHASE_ST	-- zԂǐՏԂɂ
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);	-- G̍WڕWWɂ
		Move (MyID,MyDestX,MyDestY)	-- G̍WֈړJn
		TraceAI ("ATTACK_ST -> CHASE_ST  : ENEMY_OUTATTACKSIGHT_IN")
		return
	end
	
	if (MySkill == 0) then	-- gƂĂXLȂ
		Attack (MyID,MyEnemy)	-- GU
	else	-- gƂĂXL
		SkillObject (MyID,MySkillLevel,MySkill,MyEnemy)	-- Gɑ΂đΏێwXL
		MySkill = 0	-- Ȍgp悤ƂĂXL΃LZ
	end
	TraceAI ("ATTACK_ST -> ATTACK_ST  : ENERGY_RECHARGED_IN")
	return


end


-------------------------------------------
-- ړR}htԂ̏
-------------------------------------------
function	OnMOVE_CMD_ST ()

	TraceAI ("OnMOVE_CMD_ST")

	local x, y = GetV (V_POSITION,MyID)	-- žݍW擾
	if (x == MyDestX and y == MyDestY) then		-- ڕWWɂ
		MyState = IDLE_ST	-- zԂҋ@Ԃɂ
	end
end



-------------------------------------------
-- ~R}htԂ̏
-------------------------------------------
function OnSTOP_CMD_ST ()


end


-------------------------------------------
-- ΏێwUR}htԂ̏
-------------------------------------------
function OnATTACK_OBJECT_CMD_ST ()


end


-------------------------------------------
-- ͈͍UR}htԂ̏
-------------------------------------------
function OnATTACK_AREA_CMD_ST ()

	TraceAI ("OnATTACK_AREA_CMD_ST")

	local	object = GetOwnerEnemy (MyID)	-- P~UĂG̃LN^[id擾
	if (object == 0) then			-- P~UĂGȂ
		object = GetMyEnemy (MyID) 	-- z̓G̃LN^[id擾
	end

	if (object ~= 0) then		-- G΁iP~U܂͍Uj
		MyState = CHASE_ST	-- zԂ^[QbgǐՏԂɂ
		MyEnemy = object	-- object̓G^[Qbgɂ
		return
	end

	local x , y = GetV (V_POSITION,MyID)	-- žݍW擾
	if (x == MyDestX and y == MyDestY) then		-- ڕWWɂ
			MyState = IDLE_ST	-- zԂҋ@Ԃɂ
	end

end


-------------------------------------------
-- pg[R}htԂ̏
-------------------------------------------
function OnPATROL_CMD_ST ()

	TraceAI ("OnPATROL_CMD_ST")

	local	object = GetOwnerEnemy (MyID)	-- P~UĂG̃LN^[id擾
	if (object == 0) then		-- P~UĂGȂ
		object = GetMyEnemy (MyID)	-- z̓G̃LN^[id擾
	end

	if (object ~= 0) then		-- G
		MyState = CHASE_ST	-- zԂ^[QbgǐՏԂɂ
		MyEnemy = object	-- object̓G^[Qbgɂ
		TraceAI ("PATROL_CMD_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local x , y = GetV (V_POSITION,MyID)	-- žݍW擾
	if (x == MyDestX and y == MyDestY) then		-- ڕWWɂ
		MyDestX = MyPatrolX	-- pg[n_WVڕWWɂ
		MyDestY = MyPatrolY
		MyPatrolX = x	-- ݈ʒuVpg[n_Wɂ
		MyPatrolY = y
		Move (MyID,MyDestX,MyDestY)	-- ڕWWֈړJn
	end

end


-------------------------------------------
-- z[hR}htԂ̏
-- GԂɍU
-------------------------------------------
function OnHOLD_CMD_ST ()

	TraceAI ("OnHOLD_CMD_ST")
	
	if (MyEnemy ~= 0) then	-- 풆̓G
		local d = GetDistance(MyEnemy,MyID)	-- zƓGƂ̋擾
		-- GEɂčU͈͂ɓĂ
		if (d ~= -1 and d <= GetV(V_ATTACKRANGE,MyID)) then
				Attack (MyID,MyEnemy)	-- GU
		else	-- ȊOȂ
			MyEnemy = 0;	-- G^QO
		end
		return			-- ߂
	end


	local	object = GetOwnerEnemy (MyID)	-- P~UĂG̃LN^[id擾
	if (object == 0) then	-- P~UĂGȂ
		object = GetMyEnemy (MyID)	-- z̓G̃LN^[id擾
		if (object == 0) then	-- z̓GȂ

			return		-- ߂
		end
	end

	MyEnemy = object	-- 擾G^Qɂ

end


-------------------------------------------
-- ΏێwXLR}htԂ̏
-------------------------------------------
function OnSKILL_OBJECT_CMD_ST ()
	
end


-------------------------------------------
-- ͈̓XLR}htԂ̏
-------------------------------------------
function OnSKILL_AREA_CMD_ST ()

	TraceAI ("OnSKILL_AREA_CMD_ST")

	local x , y = GetV (V_POSITION,MyID)	-- žݍW擾
	-- wWAgƂĂXL̎˒͈͓Ȃ
	if (GetDistance(x,y,MyDestX,MyDestY) <= GetV(V_SKILLATTACKRANGE,MyID,MySkill)) then
		-- ͈̓XL𔭓
		SkillGround (MyID,MySkillLevel,MySkill,MyDestX,MyDestY)
		MyState = IDLE_ST	-- zԂҋ@Ԃɂ
		MySkill = 0	-- gp悤ƂĂXL΃LZ
	end

end


-------------------------------------------
-- Ǐ]R}htԂ̏
-------------------------------------------
function OnFOLLOW_CMD_ST ()

	TraceAI ("OnFOLLOW_CMD_ST")

	local ownerX, ownerY, myX, myY
	ownerX, ownerY = GetV (V_POSITION,GetV(V_OWNER,MyID))	-- P~̍W擾
	myX, myY = GetV (V_POSITION,MyID)	-- z̍W擾

	local d = GetDistance (ownerX,ownerY,myX,myY)	-- zƃP~Ƃ̋vZ

	if ( d <= 3) then	-- 3ȓȂ
		return		-- ߂
	end

	-- zړňړ悪P~痣ĂAړLZăP~ɒǏ]
	local motion = GetV (V_MOTION,MyID)
	if (motion == MOTION_MOVE) then                       -- ʋ^~
		d = GetDistance (ownerX, ownerY, MyDestX, MyDestY)
		if ( d > 3) then		-- 3藣Ă
			MoveToOwner (MyID)	-- P~̂Ƃ܂ňړJn
			MyDestX = ownerX	-- P~̍WڕWWɂ
			MyDestY = ownerY
			return			-- ߂
		end
	else	-- ړȂ
		MoveToOwner (MyID)	-- P~̂Ƃ܂ňړJn
		MyDestX = ownerX	-- P~̍WڕWWɂ
		MyaDestY = ownerY
		return
	end
	
end


-------------------------------------------
-- P~UĂĜAzԋ߂G̃LN^[id擾
--   <߂l> G̃LN^[id
-------------------------------------------
function	GetOwnerEnemy (myid)
	local result = 0		-- G̃LN^[id
	local owner  = GetV (V_OWNER,myid)	-- P~g̃LN^[id
	local actors = GetActors ()	-- ̃LN^[idS擾
	local enemys = {}	-- G̃Xg
	local index = 1		-- CfbNXԍ(l1)
	local target		-- ^[Qbg̃LN^[id

	-- (1,actors[1])A(2,actors[2])Ac̃yAJԂ
	-- ̃LN^[idЂƂЂƂ`FbNāÃLN^[
	-- P~U悤ƂĂAGƂēGXgɒǉ
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then	-- P~zgȂ
			target = GetV (V_TARGET,v)	-- ̃LN^[̃^Q擾
			if (target == owner) then	-- ^QP~
				if (IsMonster(v) == 1) then	-- X^[
					enemys[index] = v	-- G̃Xgɒǉ
					index = index+1		-- CfbNX1₷
				else	-- X^[Ȃ
					local motion = GetV(V_MOTION,v)	-- ̃LN^[̃[V擾
					-- [VU[V
					if (motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
						enemys[index] = v	-- G̃Xgɒǉ
						index = index+1	-- CfbNX1₷
					end
				end
			end
		end
	end

	local min_dis = 100	-- ŏ(l100)
	local dis		-- 

	-- (1,enemys[1])A(2,enemys[2])Ac̃yAJԂ
	-- GXg̒ŁAzԋ߂Gz̍UΏۂƂ
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)	-- zƓGƂ̋擾
		if (dis < min_dis) then		-- ŏ߂
			result = v	-- ̓G^[QbgƂ
			min_dis = dis	-- ̓GƂ̋ŏƂ
		end
	end
	
	return result	-- ^[QbgԂ
end


-------------------------------------------
-- z̓G擾
--   <߂l> G̃LN^[id
-------------------------------------------
function	GetMyEnemy (myid)
	local result = 0	-- G̃LN^[id

	local type = GetV (V_HOMUNTYPE,myid)	-- z̃^Cv擾
	-- z LIF  AMISTR Ȃ
	if (type == LIF or type == LIF_H or type == AMISTR or type == AMISTR_H) then
		result = GetMyEnemyA (myid)	-- G擾^CvAiU^j
	-- z FILIR  VANILMIRTH Ȃ
	elseif (type == FILIR or type == FILIR_H or type == VANILMIRTH or type == VANILMIRTH_H) then
		result = GetMyEnemyB (myid)	-- G擾^CvBiU^j
	end
	return result	-- ^[QbgԂ
end


-------------------------------------------
-- G擾^CvAiU^j
-------------------------------------------
function	GetMyEnemyA (myid)
	local result = 0	-- G̃LN^[id
	local owner  = GetV (V_OWNER,myid)	-- P~g̃LN^[id
	local actors = GetActors ()	-- ̃LN^[idS擾
	local enemys = {}	-- G̃Xg
	local index = 1		-- CfbNXԍ(l1)
	local target		-- ^[Qbg̃LN^[id

	-- (1,actors[1])A(2,actors[2])Ac̃yAJԂ
	-- ̃LN^[idЂƂЂƂ`FbNāÃLN^[
	-- zU悤ƂĂAGƂēGXgɒǉ
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then	-- P~zgȂ
			target = GetV (V_TARGET,v)	-- ̃LN^[̃^Q擾
			if (target == myid) then	-- ^QzgȂ
				enemys[index] = v	-- G̃Xgɒǉ
				index = index+1		-- CfbNX1₷
			end
		end
	end

	local min_dis = 100	-- ŏ(l100)
	local dis		-- 

	-- (1,enemys[1])A(2,enemys[2])Ac̃yAJԂ
	-- GXg̒ŁAzԋ߂Gz̍UΏۂƂ
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)	-- zƓGƂ̋擾
		if (dis < min_dis) then		-- ŏ߂
			result = v	-- ̓G^[QbgƂ
			min_dis = dis	-- ̓GƂ̋ŏƂ
		end
	end

	return result
end


-------------------------------------------
-- G擾^CvBiU^j
-------------------------------------------
function	GetMyEnemyB (myid)
	local result = 0	-- G̃LN^[id
	local owner  = GetV (V_OWNER,myid)	-- P~g̃LN^[id
	local actors = GetActors ()	-- ̃LN^[idS擾
	local enemys = {}		-- G̃Xg
	local index = 1			-- CfbNXԍ(l1)
	local type		-- (gp)

	-- (1,actors[1])A(2,actors[2])Ac̃yAJԂ
	-- ̃LN^[idЂƂЂƂ`FbNāÃLN^[
	-- X^[AGƂēGXgɒǉ
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then	-- P~zgȂ
			if (1 == IsMonster(v))	then	-- X^[
				enemys[index] = v	-- G̃Xgɒǉ
				index = index+1		-- CfbNX1₷
			end
		end
	end

	local min_dis = 100	-- ŏ(l100)
	local dis		-- 

	-- (1,enemys[1])A(2,enemys[2])Ac̃yAJԂ
	-- GXg̒ŁAzԋ߂Gz̍UΏۂƂ
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)	-- zƓGƂ̋擾
		if (dis < min_dis) then		-- ŏ߂
			result = v	-- ̓G^[QbgƂ
			min_dis = dis	-- ̓GƂ̋ŏƂ
		end
	end

	return result
end


-------------------------------------------
-- zNXAIC
-------------------------------------------
function AI(myid)

	MyID = myid	-- zg̃LN^[id
	local msg	= GetMsg (myid)		-- P~͂R}h
	local rmsg	= GetResMsg (myid)	-- s͂ꂽR}h
--[[
	-- R}hƂ̐U蕪
	if msg[1] == NONE_CMD then		-- VKR}h͂Ȃ
		if rmsg[1] ~= NONE_CMD then	-- s͂ꂽR}h
			if List.size(ResCmdList) < 10 then	-- s̓R}h10Ȃ
				List.pushright (ResCmdList,rmsg)	-- s̓R}hXgɒǉ
			end
		end
	else	-- VKR}h͂
		List.clear (ResCmdList)	-- s̓R}hXgNA
		ProcessCommand (msg)	-- z̃Xe[^XXV
	end
--]]
	
	-- zԂƂ̏Ăяo
 	if (MyState == IDLE_ST) then	-- ҋ@
		OnIDLE_ST ()
	elseif (MyState == CHASE_ST) then	-- ^[QbgǐՏ
		OnCHASE_ST ()
	elseif (MyState == ATTACK_ST) then	-- U
		OnATTACK_ST ()
	elseif (MyState == FOLLOW_ST) then	-- AP~XgǏ]
		OnFOLLOW_ST ()
	elseif (MyState == MOVE_CMD_ST) then	-- ړR}ht
		OnMOVE_CMD_ST ()
	elseif (MyState == STOP_CMD_ST) then	-- ~R}ht
		OnSTOP_CMD_ST ()
	elseif (MyState == ATTACK_OBJECT_CMD_ST) then	-- ΏێwUR}ht
		OnATTACK_OBJECT_CMD_ST ()
	elseif (MyState == ATTACK_AREA_CMD_ST) then	-- ͈͍UR}ht
		OnATTACK_AREA_CMD_ST ()
	elseif (MyState == PATROL_CMD_ST) then	-- pg[R}ht
		OnPATROL_CMD_ST ()
	elseif (MyState == HOLD_CMD_ST) then	-- z[hR}ht
		OnHOLD_CMD_ST ()
	elseif (MyState == SKILL_OBJECT_CMD_ST) then	-- ΏێwXLR}ht
		OnSKILL_OBJECT_CMD_ST ()
	elseif (MyState == SKILL_AREA_CMD_ST) then	-- ͈̓XLR}ht
		OnSKILL_AREA_CMD_ST ()
	elseif (MyState == FOLLOW_CMD_ST) then	-- Ǐ]R}ht
		OnFOLLOW_CMD_ST ()
	end

end
