
LUAIDE_DEBUG = false	-- LuaIDE̓dlɑΉtO

if LUAIDE_DEBUG then
	loadlib("stdlib.dll")	-- ȂKvAȂȂ
else
--	require "strict" -- LuaIDEł͎g܂
end

require "./AI/Const"
require "Map"
require "HomAPI"
require "MobAI"

HOMUNTYPE = VANILMIRTH	-- zNX̎
DEFAULT_AI_FILE = "./AI/AI.lua"	-- ȗ̖O
OWNER_MHP = 1900 -- P~MHP
OWNER_ATK = 400	-- P~ATK
OWNER_X, OWNER_Y = 9, 9 -- P~ʒu
HOMUN_MHP = 700 -- zMHP
HOMUN_ATK = 750	-- zATK
HOMUN_X, HOMUN_Y = 10, 10 -- zʒu
ENEMY_MHP = 3000 -- GMHP
ENEMY_ATK = 25	-- GATK
ENEMY_POP_SEED = 12 -- ENEMY_POP_SEED1̊mMobpop

function ReadStdin()
	if LUAIDE_DEBUG then
		return io.read(1)
	else
		return io.read()	-- LuaIDEƋAĂȂȂ܂
	end
end

function RandomInt( max )
	return math.floor( math.random() * max )
end

function RandomId()
	return RandomInt( 50000 )
end

do
	local aifile = arg and arg[1] or DEFAULT_AI_FILE
	print( string.format("loading: %s", aifile ) )
	dofile( aifile )
	
	local ownerid = RandomId()
	local homunid = RandomId()
	local map = Map.new()
	Map.setForegroundMap( map )
	map:spawnObject( map:createObject( ownerid, MAPOBJ_OWNER, NewStatus( OWNER_MHP, 600 ) ), OWNER_X, OWNER_Y, MobAI.new() )
	map:setObjectStatus( ownerid, { ATK = OWNER_ATK } )
	map:spawnObject( map:createObject( homunid, MAPOBJ_I, NewStatus( HOMUN_MHP, 350 ) ), HOMUN_X, HOMUN_Y, MobAI.new( MobAI.Homunclus ) )
	map:setObjectStatus( homunid, { ATK = HOMUN_ATK, ownerid = ownerid, homtype = HOMUNTYPE } )
	
	local exitfrag = false
	local atkmethodtable = {
		nn = function( iter )
			AttackCommandByDirection( 0, -1 )
		end,
		ne = function( iter )
			AttackCommandByDirection( 1, -1 )
		end,
		ee = function( iter )
			AttackCommandByDirection( 1, 0 )
		end,
		se = function( iter )
			AttackCommandByDirection( 1, 1 )
		end,
		ss = function( iter )
			AttackCommandByDirection( 0, 1 )
		end,
		sw = function( iter )
			AttackCommandByDirection( -1, 1 )
		end,
		ww = function( iter )
			AttackCommandByDirection( -1, 0 )
		end,
		nw = function( iter )
			AttackCommandByDirection( -1, -1 )
		end,
		id = function( iter )
			local obj = map:setObjectStatus( ownerid, { targetid = tonumber( iter() ) } )
			TryAttack( obj )
			print("owner attack:", obj.targetid )
		end,
		pt = function( iter )
			AttackCommandByCell( tonumber( iter() ), tonumber( iter() ) )
		end,
	}
	function AttackCommandByDirection( x, y )
		local obj = map:getObject( ownerid )
		AttackCommandByCell( obj.x + x, obj.y + y )
	end
	function AttackCommandByCell( x, y )
		local list = map:getCellObjects( x, y )
		for i = list.n, 1, -1 do
			if map:isActor( list[i].id ) and IsEnemy( ownerid, list[i].id ) then
				TryAttack( map:setObjectStatus( ownerid, { targetid = list[i].id } ) )
				print("owner attack:", list[i].id, x, y )
				return
			end
		end
		print("no such enemy:", x, y )
	end
	local cmdtable = {
		q = function( line )
			exitfrag = true	-- LuaIDEos.exit()Ɨ
		end,
		w = function( line )
			MoveOwnerCommand( line, 0, -1 )
		end,
		a = function( line )
			MoveOwnerCommand( line, -1, 0 )
		end,
		s = function( line )
			MoveOwnerCommand( line, 0, 1 )
		end,
		d = function( line )
			MoveOwnerCommand( line, 1, 0 )
		end,
		h = function( line )
			print( HELP_MESSAGE )
			NextChar( ReadStdin() )
		end,
		v = function( line )
			local id = tonumber( line )
			if map:isValidObjectId( id ) then
				print("---------------")
				for k, v in pairs( map:getObject( id ) ) do
					print( k, v )
				end
				print("---------------")
			else
				print( string.format("%s - IDfX", tostring( id ) ) )
			end
			NextChar( ReadStdin() )
		end,
		z = function( line )
			local iter = string.gfind( line, "%w+" )
			local method = iter()
			local func = atkmethodtable[ method ]
			if func then
				func( iter )
			end
		end,
	}
	function MoveOwnerCommand( line, x, y )
		if not map:isActor( ownerid ) then
			return
		end
		map:setObjectStatus( ownerid, { targetid = 0 } )	-- ړɃ^QZ
		map:moveObject( ownerid, x, y )
		NextChar( line )
	end
	function NextChar( line )
		local cmd = cmdtable[ string.sub( line, 0, 1 ) ]
		if cmd then cmd( string.sub( line, 2 ) ) end
	end
	while not exitfrag do
		map:printMap()
		NextChar( ReadStdin() )	-- [U[R}hs
		
		map:stepMotion()
		
		if RandomInt( ENEMY_POP_SEED ) == 0 then
			local mobid = RandomId()
			map:spawnObject(
				map:createObject( mobid, MAPOBJ_ENEMY, NewStatus( ENEMY_MHP, 0 ) ),
				RandomInt( MAP_WIDTH ) + 1, RandomInt( MAP_HEIGHT ) + 1, MobAI.new( MobAI.Active ) ).atkrange = 1
			map:setObjectStatus( mobid, { ATK = ENEMY_ATK } )
		end
	end
end

